main()
{
	precacheModels();
	precacheFX();   
	thread startCnqStuff();

 	//if you want effects to not run, set the cvar ro_nofx = 1	
	if (getcvarint("ro_nofx") != 1) {
 		startFX();    
	  startSounds();
	}
}

startCnqStuff() {
	
  if (getcvar("g_gametype") == "cnq" ) {
    //conquest specific code
	  setupCnqCallbacks();
	  startupCnqRadioSounds();
  }

}

precacheModels() {
	precacheModel("xmodel/M109");
	precacheModel("xmodel/PzIIIAusfgrey");
	precacheModel("xmodel/PzIIIAusfgreydamaged");

}

precacheFX() {

	level._effect["tigertankexplosion"]	= loadfx("fx/explosions/explosion1_nolight.efx");
	level._effect["fueltank"]		= loadfx("fx/explosions/fueltank_ned.efx");
	level._effect["wood_close"]		= loadfx ("fx/cannon/wood_close.efx");
  level._effect["wood"]			= loadfx ("fx/cannon/wood.efx");
  level._effect["dust"]			= loadfx ("fx/cannon/dust.efx");
  level._effect["dirt"]			= loadfx ("fx/cannon/dirt.efx");
	level._effect["fire"] = loadfx ("fx/fire/fireheavysmoke.efx");
  level._effect["smoke"] = loadfx ("fx/smoke/dawnville_smoke3.efx");
	level._effect["heavysmoke"] = loadfx("fx/smoke/neuville_smoke1.efx");
	level._effect["flak_burst"] = loadfx ("fx/muzzleflashes/mortarflash.efx");
	level.mg42_effect = loadfx ("fx/muzzleflashes/mg42hv.efx");
	level.mg42_effect2 = loadfx ("fx/muzzleflashes/mg42hv_nosmoke.efx");
	level._effect["sparkie"] = loadfx ("fx/misc/sparker.efx");
}

startFX() {

  firespots = getentarray ("smokeandfire", "targetname");
  for (i = 0; i < firespots.size; i++) {
		maps\mp\_fx::loopfx("smoke", firespots[i].origin, 0.5);
		maps\mp\_fx::loopfx("fire", firespots[i].origin + (0,0,10), 0.6);
  	firespots[i] playLoopSound ("smallfire", firespots[i].origin, undefined);
  }

  smokespots = getentarray ("smoke", "targetname");
  for (i = 0; i < smokespots.size; i++) {
		maps\mp\_fx::loopfx("smoke", smokespots[i].origin, 0.5);
  }

  heavysmokespots = getentarray ("heavysmoke", "targetname");
  for (i = 0; i < heavysmokespots.size; i++) {
	  maps\mp\_fx::loopfx("heavysmoke", heavysmokespots[i].origin, 0.3);
  }
  
 	thread startTank();
	thread startPlanes(); 	
}

startTank() {

	tank = getent("hilltank", "targetname");
	if (isdefined(tank)) {
		while (1) {
 		  maps\mp\_fx::OneShotfx("flak_burst", (862, -2761, 187),0, (977, -2720, 189));
	  	tank playsound ("flak88_fire");
  	  wait (randomint(2)*15);
  	}
  }
}

startPlanes() {
 
 	wait 5;
 
  flybyStartNodes = getentarray("start109", "targetname");
  if (!isdefined(flybyStartNodes))
  	return;

  plane = spawn_model("xmodel/M109", "109", (0,0,0), (0,0,0));
	
	while (1) {
				nodeIdx = randomint(flybyStartNodes.size);
				waittime = (randomint(1)+ 2) * 60;
  			wait (waittime);
        flyby(plane, flybyStartNodes[nodeIdx]);
	}
  
}

flyby(plane, startNode) {
  
  if (!isdefined (startNode.target)) 
    return;

  pathNodes = buildPath(startNode);
	if (!isdefined(pathNodes))
		return;
			
	plane playsound ("ro_109_flyby");
	wait 4;
	
	speed = 5;
	if (pathNodes.size > 2)
		speed = 0.5; 
  plane.origin = startNode.origin;
  plane.angles = startNode.angles;
  plane show();
  for (i = 0; i < pathNodes.size; i++ ) {
    plane rotateto (pathNodes[i].angles, speed);    
    plane moveto (pathNodes[i].origin, speed);
    wait (speed - 0.05);
  }
  plane hide();
}

startSounds() {
  artysound = getent("artysource", "targetname");
  if (isdefined(artysound)) {
    while (1) {
      artysound playSound ("ro_arty");
      wait (randomint(15));
    }
  }

}

setupCnqCallbacks() {
  level.cnqCallbackSpawnObjectiveComplete = ::Callback_SpawnObjectiveComplete;
  level.cnqCallbackBonusObjectiveComplete = ::Callback_BonusObjectiveComplete;
  level.cnqCallbackBonusObjectiveRegen =  ::Callback_BonusRegen;
}

Callback_BonusObjectiveComplete(objective, player) {
  objective playsound ("ro_throw_switch");
  maps\mp\_fx::loopfx("sparkie", objective.origin, 3.0, undefined, "sparkie", "sparkie");
  wait 0.5;
  level notify("start fxsparkie");
}

Callback_BonusRegen(objective) {
  wait 0.5;
  level notify("stop fxsparkie");
}

Callback_SpawnObjectiveComplete(objective, player) {
  wait 0.5;
  if (player.pers["team"] == "axis") { 
		objective stoploopsound();
	  wait 0.5;
		objective playloopsound ("ro_axis_radio");  
  } else {
		objective stoploopsound();
	  wait 0.5;
		objective playloopsound ("ro_allies_radio");  
  }
}

startupCnqRadioSounds () {
	
  radioSound = "ro_allies_radio";
  if (game["attackers"] == "allies")
	  radioSound = "ro_axis_radio";

  radios = getentarray("spawnobjective", "targetname");
  if (!isdefined(radios)) {	
  	return;
  }
  for (i = 0; i < radios.size; i++)
  	radios[i] playloopsound(radioSound);
}

buildPath (fromNode) {
	  pathNodes = [];
	  //pathNodes[0] = fromNode;
	  nextNode = getent(fromNode.target, "targetname");
	  while (isdefined(nextNode)) {
	    pathNodes[pathNodes.size] = nextNode;
	    if (!isdefined(nextNode.target))
	      nextNode = undefined;
	    else      
	      nextNode = getent(nextNode.target, "targetname");
	  }
		return pathNodes;
}

spawn_model(model, targetname, origin, angles) {
  
  if (!isdefined(model) || !isdefined(targetname) || !isdefined(origin))
    return undefined;
  
  if (!isdefined(angles)) angles = (0,0,0);
  
  spawn = spawn ("script_model",(0,0,0));
  spawn.origin = origin;
  spawn setmodel (model);
  spawn.targetname = targetname;
  spawn.angles = angles;
  
  return spawn;
}